import sys
import shutil
import os
import os.path
import tarfile

g_tar_ext = '.tar'

def starts_with(string, start):
  return string[0:len(start)] == start

def ends_with(string, end):
  return string[-len(end):] == end

def pathnames(path):
  dir_path = ''
  tar_path = ''
  if ends_with(path, g_tar_ext):
    dir_path = path[0 : len(path) - len(g_tar_ext)]
    tar_path = path
  else:
    dir_path = path
    tar_path = path + g_tar_ext
  return (tar_path, dir_path)

def pack(path):
  tar_path, dir_path = pathnames(path)

  if not os.path.isdir(dir_path):
    print "Directory does not exist: " + dir_path
    return

  tar = tarfile.open(os.path.basename(tar_path), "w:gz")
  tar.add(dir_path, os.path.basename(dir_path))
  tar.close()

  print
  print "Pack done."

def unpack(path):
  tar_path, dir_path = pathnames(path)

  if not os.path.isfile(tar_path):
    print "Tar file does not exist: " + tar_path
    return
    
  if os.path.isdir(dir_path):
    shutil.rmtree(dir_path)

  tar = tarfile.open(tar_path, "r")
  tar.extractall()
  tar.close

  print
  print "Unpack done."


if __name__ == "__main__":
  args = sys.argv[1:]
  
  if len(args) == 0 or (args[0] != 'pack' and args[0] != 'unpack'):
    print "Usage: exe_name [pack | unpack] [directory | tar_file]"
  else:
    if args[0] == 'pack':
      for item in args[1:]:
        pack(item)
    else:
      for item in args[1:]:
        unpack(item)
  
  

